#include <EEPROM.h>

//Настраиваем предварительно сервомоторы робота
#include <Servo.h>
#include "sg90.h"

//=========================
// создаем структуры ног и головы
// we create structures of feet and the head
struct front_foot
{
 sg90 low, hight, plecho; 
};
//=========================
struct back_foot
{
 sg90 low, hight; 
};
//=========================
struct head
{
 sg90 neck, head; 
};
//=========================
//=========================
// Объявляем ноги и голову
// We declare feet and the head
front_foot left_front, right_front;
//=========================
back_foot left_back, right_back;
//=========================
head robo_head;
//=========================



void setup() 
{ 
  int addr=0;
  // прикрепляем приводы к объектам программы
  
 EEPROM.write(addr,18); // it's indentificator of zizibot as is
 addr++;
 EEPROM.write(addr,05); // it's indentificator of zizibot model number
 addr++;
 EEPROM.write(addr,05); // it's indentificator of zizibot number in model raw 1'b
 addr++;
 EEPROM.write(addr,00); // it's indentificator of zizibot number in model raw 2'b
 addr++;
// 4 byte 
 addr=addr+6; // пропускаем поля даты

  // предварительно настраиваем центральные точки в программе zizibot_90
  //previously we adjust the central points in program zizibot_90
  // начало блока
  // begin block
 left_front.low.centralPoint=97; 
  left_front.hight.centralPoint=83;
  left_front.plecho.centralPoint=85;

  right_front.low.centralPoint=95;
  right_front.hight.centralPoint=99;
  right_front.plecho.centralPoint=78;

  left_back.low.centralPoint=85;
  left_back.hight.centralPoint=110;

  right_back.low.centralPoint=90;
  right_back.hight.centralPoint=90;

  robo_head.neck.centralPoint=105;
  robo_head.head.centralPoint=135;
  // конец блока копируемого из программы предварительной настройки
  // the end of the block copied from the program of preliminary control

  // write centralPoints in EEPROM
  EEPROM.write(addr,left_front.low.centralPoint); 
  addr++;
  EEPROM.write(addr,left_front.hight.centralPoint);
  addr++;
  EEPROM.write(addr,left_front.plecho.centralPoint);
  addr++;
  EEPROM.write(addr,right_front.low.centralPoint);
  addr++;
  EEPROM.write(addr,right_front.hight.centralPoint);
  addr++;
  EEPROM.write(addr,right_front.plecho.centralPoint);
  addr++;
  EEPROM.write(addr,left_back.low.centralPoint);
  addr++;
  EEPROM.write(addr,left_back.hight.centralPoint);
  addr++;
  EEPROM.write(addr,right_back.low.centralPoint);
  addr++;
  EEPROM.write(addr,right_back.hight.centralPoint);
  addr++;
  EEPROM.write(addr,robo_head.neck.centralPoint);
  addr++;
  EEPROM.write(addr,robo_head.head.centralPoint);
  addr++;

  // устанавливаем пин как вывод управления серводами 
  left_front.low.attach(2);left_front.hight.attach(3);left_front.plecho.attach(10);
  right_front.low.attach(4);right_front.hight.attach(5);right_front.plecho.attach(11);
  left_back.low.attach(6);left_back.hight.attach(7);
  right_back.low.attach(8);right_back.hight.attach(9);
  robo_head.head.attach(13);robo_head.neck.attach(12);//
 
}
//=============================================================================
//================ BEGIN  =====================================================
//================ НАЧАЛО =====================================================
//=============================================================================
void loop() 
{

  // Устанавливаем приводы в серединное значение
  left_front.low.writeCentrP();    left_front.hight.writeCentrP();
  right_front.low.writeCentrP();  right_front.hight.writeCentrP();
  left_back.low.writeCentrP();  left_back.hight.writeCentrP();
  right_back.low.writeCentrP();  right_back.hight.writeCentrP();
  robo_head.neck.writeCentrP();  robo_head.head.writeCentrP();
  left_front.plecho.writeCentrP();  right_front.plecho.writeCentrP();
  delay(1000); 
 

}
