// ZiziBot с голосовым модулем
// реализована система центрирования серводатчиков

#include <Servo.h>

#include "sg90.h"

//аудио начало


int error = 0;

const int Trig=14; const int Echo=15;
const int hug=20;// угол подьема верхней фаланги
const int  low_h=70; // угол подьема нижней фаланги
const int st_delay=250;
const int stt_delay=80;
//=========================
// Передняя нога
struct front_foot
{
  // Нижняя фаланга, верхняя, поворот ноги.
 sg90 low, hight, plecho; 
};
//=========================
// Задняя нога
struct back_foot
{
  // Нижняя фаланга, верхняя.
 sg90 low, hight; 
};
//=========================
// Голова на шее
struct head
{
  // шея, голова.
 sg90 neck, head; 
};
//=========================
// Создаем передние ноги.
front_foot left_front, right_front;
//=========================
// Создаем задние ноги.
back_foot left_back, right_back;
//=========================
// Создаем голову.
head robo_head;
//=============================================================================
//=============================================================================
// Робот стоит
void _stoyka() //1 вперед 0-назад
{

  left_front.low.writeCentrP();    left_front.hight.writeCentrP();
  right_front.low.writeCentrP();  right_front.hight.writeCentrP();
  left_back.low.writeCentrP();  left_back.hight.writeCentrP();
  right_back.low.writeCentrP();  right_back.hight.writeCentrP();
  robo_head.neck.writeCentrP();  robo_head.head.writeCentrP();
  left_front.plecho.writeCentrP();  right_front.plecho.writeCentrP();
  delay(st_delay);
}
//=============================================================================
//=============================================================================
//=============================================================================
//=============================================================================
//=============================================================================
void _stable() // стабилизируем ноги путем поворота до упора в обе стороны
{
  left_front.low.stable_0(); left_front.hight.stable_0(); left_front.plecho.stable_0();
  right_front.low.stable_0(); right_front.hight.stable_0(); right_front.plecho.stable_0();
  left_back.low.stable_0(); left_back.hight.stable_0();
  right_back.low.stable_0(); right_back.hight.stable_0();
  robo_head.head.stable_0(); robo_head.neck.stable_0();
}
//=============================================================================
//=============================================================================
//=============================================================================
//=============================================================================
void setup() 
{ 
 // Поднастройка ног на точную середину- производится по факту...
 // !!!Эти значения индивидуальны для каждого зизибота!!!
 // Смотрим на результат (на включенном роботе) и корректируем.
  left_front.low.centralPoint=97; 
  left_front.hight.centralPoint=83;
  left_front.plecho.centralPoint=85;

  right_front.low.centralPoint=95;
  right_front.hight.centralPoint=99;
  right_front.plecho.centralPoint=84;

  left_back.low.centralPoint=85;
  left_back.hight.centralPoint=110;

  right_back.low.centralPoint=90;
  right_back.hight.centralPoint=90;

  robo_head.neck.centralPoint=105;
  robo_head.head.centralPoint=114;

  // устанавливаем пин как вывод управления серводами 
  left_front.low.attach(2);left_front.hight.attach(3);left_front.plecho.attach(10);
  right_front.low.attach(4);right_front.hight.attach(5);right_front.plecho.attach(11);
  left_back.low.attach(6);left_back.hight.attach(7);
  right_back.low.attach(8);right_back.hight.attach(9);
  robo_head.head.attach(13);robo_head.neck.attach(12);//
  //==================================================================================
// _stable();

  _stoyka();
  
  
}
 
void loop() 
{

}
//=============================================================================
//=============================================================================

